<?php
define('ABS_PATH', dirname(dirname(dirname(dirname(dirname(dirname(__FILE__)))))) . '/');
require_once ABS_PATH . 'oc-load.php';

$MerchantID = payment_decrypt(osc_get_preference('faragate_api', 'payment'));   //Required
$rpl = $_GET['rpl'];
$data = payment_get_custom($rpl);
$currency = osc_get_preference('currency', 'payment');


$InvoiceNumber = isset($_POST['InvoiceNumber']) ? $_POST['InvoiceNumber'] : '';
$Transaction_ID = $Token = isset($_POST['Token']) ? $_POST['Token'] : '';

if (extension_loaded('soap')) {
    if (isset($_POST['Status']) && $_POST['Status'] == 1) {
        try {

            $client = new SoapClient('http://faragate.com/services/soap?wsdl', array('encoding' => 'UTF-8'));
            $Request = $client->PaymentVerify(array(
                    'SandBox' => !empty($_POST['SandBox']),
                    'MerchantCode' => $MerchantID,
                    'Token' => $Token
                )
            );

            if (isset($Request->Status) && $Request->Status == 1) {
                $Status = 'completed';
                $Fault = '';
            } else {
                $Status = 'failed';
                $Fault = isset($Request->Status) ? $Request->Status : '';
                $Message = isset($Request->Message) ? $Request->Message : ''; //not already , maybe later
            }
        } catch (Exception $ex) {
            $Message = $ex->getMessage();
        }
    } else {
        $Status = 'failed';
        $Fault = isset($_POST['Status']) ? $_POST['Status'] : '';
    }
} else {
    $Status = 'failed';
    $Fault = '-26';
}


if ($Status == 'completed') {

    $exists = ModelPayment::newInstance()->getPaymentByCode($Transaction_ID, 'FARAGATE');
    if (isset($exists['pk_i_id'])) {
        $message = 'قبلا پرداخت شده است.';
    } elseif (!$exists['pk_i_id']) {
        $product_type = explode('x', $data['product']);
        $payment_id = ModelPayment::newInstance()->saveLog(
            $data['concept'], //concept
            $Transaction_ID, // transaction code
            $data['amount'] / 1000000000000, //amount
            $currency, //currency
            $data['email'], // payer's email
            $data['user'], //user
            $data['itemid'], //item
            $product_type[0], //product type
            'FARAGATE'); //source
        if ($product_type[0] == '101') {
            ModelPayment::newInstance()->payPublishFee($product_type[2], $payment_id);
        } else if ($product_type[0] == '201') {
            ModelPayment::newInstance()->payPremiumFee($product_type[2], $payment_id);
        } else {
            ModelPayment::newInstance()->addWallet($data['user'], $data['amount']);
        }
        $message = 'پرداخت انجام گرديد<br/>شماره رسيد پرداخت: ' . $Transaction_ID;
    }
} else {

    switch ($Fault) {

        case '-1' :
            $Response = 'نوع درخواست معتبر نيست .';
            break;

        case '-2' :
            $Response = 'مرچنت کد پذيرنده معتبر نيست .';
            break;

        case '-3' :
            $Response = 'شماره فاکتور معتبر نيست .';
            break;

        case '-4' :
            $Response = 'مقدار مبلغ معتبر نيست .';
            break;

        case '-5' :
            $Response = 'پست الکترونيکي پرداخت کننده معتبر نيست .';
            break;

        case '-6' :
            $Response = 'شماره موبايل پرداخت کننده معتبر نيست .';
            break;

        case '-7' :
            $Response = 'فيلدهاي  Query String معتبر نيستند .';
            break;

        case '-8' :
            $Response = 'فيلدهاي Post معتبر نيستند .';
            break;

        case '-9' :
            $Response = 'اطلاعات واريز به شماره حساب ها معتبر نيست .';
            break;

        case '-10' :
            $Response = 'کد درگاه معتبر نيست يا درگاه پذيرنده فعال نيست .';
            break;

        case '-11' :
            $Response = 'آدرس بازگشت به درگاه پذيرنده معتبر نيست .';
            break;

        case '-12' :
            $Response = 'مرچنت کد وارد شده براي اين سايت نمي باشد .';
            break;

        case '-13' :
            $Response = 'آي پي درخواست کننده معتبر نيست .';
            break;

        case '-14' :
            $Response = 'بانک عامل معتبر نيست .';
            break;

        case '-15' :
            $Response = 'متاسفانه مشکلي در شبکه بانکي وجود دارد .';
            break;

        case '-16' :
            $Response = 'مقدار کليد پرداخت اشتباه است .';
            break;

        case '-17' :
            $Response = 'پرداخت قبلا استعلام شده و توسط بانک تاييد نشده است .';
            break;

        case '-18' :
            $Response = 'پرداخت انجام نشده است .';
            break;

        case '-19' :
            $Response = 'پرداخت برگشت خورده است .';
            break;

        case '-20' :
            $Response = 'پرداخت توسط بانک تاييد نشد .';
            break;

        case '-21' :
            $Response = 'پرداخت توسط بانک واريز نشد .';
            break;

        case '-22' :
            $Response = 'پرداخت برگشت زده شد .';
            break;

        case '-23' :
            $Response = 'پاسخي از بانک دريافت نشد .';
            break;

        case '-24' :
            $Response = 'اطلاعات پرداخت کننده معتبر نيست  (براي حالتي که با حساب فراگيت پرداخت انجام ميشود) .';
            break;

        case '-25' :
            $Response = 'خطا در پايگاه داده درگاه رخ داده است .';
            break;

        case '-26' :
            $Response = 'ماژول SOAP بر روي هاست فعال نمي باشد .';
            break;

        default :
            $Response = 'تراکنش انجام نشد .';
            break;
    }

    $message = 'خطايي در اعتبار سنجي پرداخت به وجود آمده است ! وضعيت خطا : ' . $Response . '<br>کد پيگيري را نزد خود نگه داريد کنيد : ' . $Transaction_ID;
}

osc_add_flash_ok_message($message);
payment_js_redirect_to(osc_route_url('payment-user-menu'));
?>